# $Revision: 1.69 $, $Date: 2011/12/31 11:24:29 $
#
# Conditional build:
%bcond_with	jumbopatch	# This patch integrates lots of contributed
				# patches adding support for over 30
				# of additional hash types, and more.
%bcond_with	avx		# use x86 AVX instructions
%bcond_with	xop		# use x86 XOP instructions
%bcond_with	altivec		# use PPC Altivec instructions
#
%ifarch i586 i686 athlon pentium2 pentium3 pentium4
%define do_mmx 1
%else
%define	do_mmx 0
%endif
%ifarch	i686 athlon pentium4
%define	do_sse2 1
%else
%define	do_sse2 0
%endif
%ifarch i586 i686
%define do_mmxfb 1
%define	optmmxfb	-DCPU_FALLBACK=1
%else
%define do_mmxfb 0
%undefine optmmxfb
%endif
%ifarch i686 athlon
%define	do_ssefb 1
%define	optssefb	-DCPU_FALLBACK=1
%else
%define	do_ssefb 0
%define	optssefb
%endif
Summary:	Password cracker
Summary(pl.UTF-8):	Łamacz haseł
Name:		john
Version:	1.7.9
Release:	1
License:	GPL v2
Group:		Applications/System
Source0:	http://www.openwall.com/john/g/%{name}-%{version}.tar.bz2
# Source0-md5:	45f54fc59386ecd67daaef9f19781d93
Patch0:		%{name}-mailer.patch
Patch1:		optflags.patch
Patch2:		http://www.openwall.com/john/g/%{name}-1.7.9-jumbo-5.diff.gz
# Patch2-md5:	68cacb612f20c71eed6c24cbaf28148a
Patch3:		%{name}-jumbo-optflags.patch
URL:		http://www.openwall.com/john/
%{?with_jumbopatch:BuildRequires: openssl-devel >= 0.9.7}
BuildRequires:	rpmbuild(macros) >= 1.213
Requires:	words
%ifarch %{ix86} %{x8664}
%if %{with xop}
Requires:	cpuinfo(xop)
%endif
%if %{with xop} || %{with avx}
Requires:	cpuinfo(avx)
%endif
%if %{do_sse2} && !%{do_ssefb}
Requires:	cpuinfo(sse2)
%endif
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
John the Ripper is a fast password cracker, currently available for
many flavors of Unix (11 are officially supported, not counting
different architectures), DOS, Win32, BeOS, and OpenVMS (the latter
requires a contributed patch). Its primary purpose is to detect weak
Unix passwords. Besides several crypt(3) password hash types most
commonly found on various Unix flavors, supported out of the box are
Kerberos/AFS and Windows NT/2000/XP LM hashes, plus several more with
contributed patches.

%description -l pl.UTF-8
John The Ripper jest szybkim "łamaczem" haseł dostępnym dla wielu
rodzajów uniksów (oficjalnie obsługiwanych jest 11, nie licząc różnych
architektur), DOS-a, Win32, BeOS-a i OpenVMS-a (ten ostatni wymaga
łaty). Głównym zastosowaniem jest wykrywanie słabych haseł uniksowych.
Oprócz różnych rodzajów skrótów haseł crypt(3) najczęściej używanych
na różnych uniksach, obsługiwane są także skróty Kerberos/AFS oraz
Windows NT/2000/XP LM, a także kilka innych przy użyciu łat.

%prep
%setup -q
%patch0 -p1
%{!?with_jumbopatch:%patch1 -p1}
%{?with_jumbopatch:%patch2 -p1}
%{?with_jumbopatch:%patch3 -p1}

%{__rm} doc/INSTALL

%build
cd src

cat > defs.h <<'EOF'
#define	JOHN_SYSTEMWIDE 1
#define	JOHN_SYSTEMWIDE_EXEC "%{_libdir}/john"
EOF

%if %{do_mmxfb}
%{__make} linux-x86-any \
	CC="%{__cc}" \
	OPTFLAGS="%{rpmcflags} -include defs.h"
mv ../run/john ../run/john-non-mmx
%{__make} clean
%endif

%if %{do_ssefb}
%{__make} linux-x86-mmx \
	CC="%{__cc}" \
	OPTFLAGS="%{rpmcflags} -include defs.h %{?optmmxfb}"
mv ../run/john ../run/john-non-sse
%endif

TARG=generic
%ifarch %{x8664}
	TARG=linux-x86-64%{?with_xop:-xop}%{!?with_xop:%{?with_avx:-avx}}
%endif
%ifarch	%{ix86}
	%if %{with xop} || %{with avx}
		TARG=linux-x86%{?with_xop:-xop}%{!?with_xop:%{?with_avx:-avx}}
	%else
		%if %{do_sse2}
			TARG=linux-x86-sse2
		%else
			%if %{do_mmx}
				TARG=linux-x86-mmx
			%else
				TARG=linux-x86-any
			%endif
		%endif
	%endif
%endif
%ifarch ppc
	TARG=linux-ppc32%{?with_altivec:-altivec}
%endif
%ifarch ppc64
	TARG=linux-ppc64%{?with_altivec:-altivec}
%endif
%ifarch alpha
	TARG=linux-alpha
%endif
%ifarch ia64
	TARG=linux-ia64
%endif
%ifarch sparc sparcv9
	TARG=linux-sparc
%endif

%{__make} $TARG \
	CC="%{__cc}" \
	OPTFLAGS='%{rpmcflags} -include defs.h %{?optmmxfb}'

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_datadir}/john}
cp -a run/{*.conf,*.chr,*.lst} $RPM_BUILD_ROOT%{_datadir}/john
install -p run/john $RPM_BUILD_ROOT%{_bindir}
%if %{do_mmxfb}
install -D -p run/john-non-mmx $RPM_BUILD_ROOT%{_libdir}/john/john-non-mmx
%endif
%if %{do_ssefb}
install -D -p run/john-non-sse $RPM_BUILD_ROOT%{_libdir}/john/john-non-sse
%endif

ln -sf john $RPM_BUILD_ROOT%{_bindir}/unafs
ln -sf john $RPM_BUILD_ROOT%{_bindir}/unique
ln -sf john $RPM_BUILD_ROOT%{_bindir}/unshadow

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc doc/* run/mailer
%attr(755,root,root) %{_bindir}/john
%attr(755,root,root) %{_bindir}/unafs
%attr(755,root,root) %{_bindir}/unique
%attr(755,root,root) %{_bindir}/unshadow
%if %{do_mmxfb} || %{do_ssefb}
%dir %{_libdir}/john
%if %{do_mmxfb}
%attr(755,root,root) %{_libdir}/john/john-non-mmx
%endif
%if %{do_ssefb}
%attr(755,root,root) %{_libdir}/john/john-non-sse
%endif
%endif
%{_datadir}/john

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: john.spec,v $
Revision 1.69  2011/12/31 11:24:29  adamg
- jumbo patch up to 1.7.9-jumbo-5

Revision 1.68  2011/11/27 10:07:06  qboosh
- updated to 1.7.9 (no jumbo path for this version yet)
- updated optflags patch

Revision 1.67  2011/07/03 10:10:37  adamg
- store jumbo patch in df
- solve conflict between optflags and jumbo patches

Revision 1.66  2011/07/03 09:54:55  adamg
- missing endif

Revision 1.65  2011/07/03 09:53:20  adamg
- updated to 1.7.8; jumbo patch updated to 1.7.8-jumbo-2

Revision 1.64  2011/07/03 09:47:55  adamg
- no bcond for Patch/Source, need all files in srpm

Revision 1.63  2011/04/30 09:43:20  qboosh
- cpuinfo() requires for xop/avx/sse2

Revision 1.62  2011/04/30 09:32:04  qboosh
- updated to 1.7.7
- build with sse2 support on i686/athlon/pentium4 (with fallback on i686/athlon)
- bcond to enable avx or xop on x86*
- bcond to enable altivec on ppc*
- use more specific targets for ppc* and ia64

Revision 1.61  2010/11/05 11:23:28  glen
- fix ix86 build, by passing JOHN_SYSTEMWIDE_EXEC via include file; rel 2

Revision 1.60  2010/11/05 11:21:48  glen
- add optflags patch, cosmetics

Revision 1.59  2010/11/04 10:11:17  glen
- up to 1.7.6

Revision 1.58  2010/01/03 21:32:36  adamg
- updated to 1.7.4

Revision 1.57  2009/11/13 18:41:03  glen
- s/path/patch/

Revision 1.56  2009/11/12 17:58:09  dirdival
- jumbo path added (bcond_with jumbopatch)
- release 2

Revision 1.55  2009/11/10 23:11:13  dirdival
- up to 1.7.3.4

Revision 1.54  2008/07/20 22:46:44  adamg
- updated to 1.7.3.1

Revision 1.53  2007/02/13 08:06:36  glen
- tabs in preamble

Revision 1.52  2007/02/12 00:48:57  baggins
- converted to UTF-8

Revision 1.51  2007/02/11 00:41:18  areq
- 1.7.2

Revision 1.50  2006/03/23 23:12:22  areq
- 1.7.0.2

Revision 1.49  2006/03/11 16:08:11  areq
- 1.7.0.1

Revision 1.48  2006/02/28 23:37:25  glen
- adapterized (killed trailing spaces/tabs)

Revision 1.47  2006/02/18 14:06:23  qboosh
- updated descs

Revision 1.46  2006/02/18 13:55:15  qboosh
- use non-mmx exec fallback on i[56]86
  build x86-any on i[34]86, x86-mmx on athlon/pentium[234], both on i[56]86

Revision 1.45  2006/02/18 13:33:53  qboosh
- dropped obsolete K6 comment, updated sparc* targets

Revision 1.44  2006/02/17 21:28:04  qboosh
- removed extra nl

Revision 1.43  2006/02/12 21:35:22  areq
- clean up inspired by Solar Designer

Revision 1.42  2006/01/29 00:22:37  areq
- start update to 1.7

Revision 1.41  2005/05/11 15:27:01  qboosh
- use x8664 macro

Revision 1.40  2005/04/06 13:36:56  arekm
- add john-1.6.37-bigpatch-11.diff.gz

Revision 1.39  2005/03/26 20:58:30  darekr
- BR: sed 4.0

Revision 1.38  2005/03/26 18:18:05  adamg
- fix path to john.conf and *.chr files (john now works on amd64)
- release 7

Revision 1.37  2004/08/12 11:16:56  undefine
- release 6, builds...

Revision 1.36  2004/08/12 10:57:31  undefine
- support for AMD64(not tested)

Revision 1.35  2004/08/12 10:50:06  undefine
- release 5

Revision 1.34  2004/08/12 10:48:45  undefine
- disable linux-sparc target on sparc32 - it's really sparv8 asm version(but doesn't work on sparcv9 machines too(?))

Revision 1.33  2004/08/08 11:09:14  havner
- rel 4

Revision 1.32  2004/07/25 09:27:18  zagrodzki
- requires: words

Revision 1.31  2004/04/15 11:40:46  paszczus
- added URL

Revision 1.30  2004/04/15 11:21:36  blues
- release 3 (rel 2 for RA) - STBR

Revision 1.29  2004/02/28 14:21:53  qboosh
- fixed Source0 URL

Revision 1.28  2004/02/28 13:04:47  qboosh
- really updated to 1.6.37, removed obsolete 1.6.34 patch, updated PLD.diff
- new-style bcond, release 2

Revision 1.27  2004/02/23 22:37:50  adamg
- updated to 1.6.37

Revision 1.26  2003/12/06 16:17:20  undefine
- release 2 to rebuild with ac

Revision 1.25  2003/07/12 10:25:03  wolf
- up to 1.6.34 (much faster)
- enable mmx on athlon by default

Revision 1.24  2003/05/28 12:59:15  malekith
- massive attack: source-md5

Revision 1.23  2003/05/25 05:49:10  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.22  2002/11/27 21:10:39  juandon
- new %doc

Revision 1.21  2002/11/02 22:43:48  wolf
- %__cc

Revision 1.20  2002/04/27 14:15:31  blues
- description improved

Revision 1.19  2002/04/27 14:07:09  blues
- Release 6
- cosmetics and INSTALL removed

Revision 1.18  2002/04/25 16:39:40  arturs
- fixed a small typo

Revision 1.17  2002/02/22 23:29:05  kloczek
- removed all Group fields translations (our rpm now can handle translating
  Group field using gettext).

Revision 1.16  2002/01/18 02:13:27  kloczek
- perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.15  2001/06/04 14:44:21  baggins
- typo

Revision 1.14  2001/05/22 09:06:26  wiget
- switch to new conditional builds macros (bcond_on_ -> _with_/bcond_off_ -> _without_); no release changes only simple s/// perfored

Revision 1.13  2001/04/30 16:05:20  kloczek
- added using %{rpmcflags} macro.

Revision 1.12  2001/02/16 00:33:49  qboosh
- /usr/dict/linux.words -> /usr/share/dict/words (in config)
- choose CPU basing on target arch (and bcond :( ), not builder arch
- adapterized
- release 5

Revision 1.11  2000/05/21 15:02:33  kloczek
- spec adapterized.

Revision 1.10  2000/04/01 11:14:47  zagrodzki
- changed all BuildRoot definitons
- removed all applnkdir defs
- changed some prereqs/requires
- removed duplicate empty lines

Revision 1.9  2000/03/28 16:54:34  baggins
- translated kloczkish into english

Revision 1.8  2000/02/10 15:29:03  wiget
- update source URL

Revision 1.7  1999/07/20 11:04:33  baggins
- fixed usage of macros
- added/removed neccesary/obsolete patches
- FHS 2.0 compliance where needed
- gzipping docs where needed

Revision 1.6  1999/07/12 23:06:00  kloczek
- added using CVS keywords in %changelog (for automating them).
